#!/usr/bin/python
"""Eep RDF API: Inference Engine Tests"""

import eep, query, infer, template

def test(): 
   store = eep.parse("""<#Sean> <#likes> <#TheSimpsons> .
                        <#Sean> <#likes> <#TheSemanticWeb> .
                        <#Aaron> <#name> "Aaron" .
                        <#Aaron> <#likes> <#ThePlex> .
                        <#Sean> <#name> "Sean" .""")
   r = template.rule('?x <#name> ?y .\n?x <#likes> ?z .', 
                     '<p>(?z) is liked by (?y)</p>\n')
   print template.format("<html>", template.filter(r, store), "</html>")

   store = eep.parse("""<#Bob> <#sonOf> <#Fred> .
                        <#Fred> <#sonOf> <#John> .
                        <#John> <#sonOf> <#Wayne> .""")
   r = template.rule('?x <#sonOf> ?y .\n?y <#sonOf> ?z .', 
                     '<p>(?x) is the grandchild of (?z)</p>\n')
   print template.format("<html>", template.filter(r, store), "</html>")

if __name__=="__main__": 
   test()